searchData={"items":[{"type":"module","title":"Snap","doc":"Provides macros for instant snapshot testing, that is, macros that automatically amend\nthe source code of the test file at their call site with the evaluated value of the expression\nunder test.","ref":"Snap.html"},{"type":"macro","title":"Snap.snap_assert/1","doc":"Modifies the source code of the test file at the call site, adding the evaluated value of `arg` as the second argument.","ref":"Snap.html#snap_assert/1"},{"type":"macro","title":"Snap.snap_assert/2","doc":"With two arguments, `snap_assert` is equivalent to a regular `assert`","ref":"Snap.html#snap_assert/2"},{"type":"macro","title":"Snap.snap_assert_raise/1","doc":"Modifies the source code of the test file at the call site, adding the exception produced by `fun`\nas the first argument (or `Snap.UnexpectedLackOfException` if no exception is produced).","ref":"Snap.html#snap_assert_raise/1"},{"type":"macro","title":"Snap.snap_assert_raise/2","doc":"With two arguments, `snap_assert_raise` is equivalent to a regular `assert_raise`","ref":"Snap.html#snap_assert_raise/2"},{"type":"extras","title":"snap_assert","doc":"# snap_assert\n\nAn experiment in self-modifying code, or, instant snapshot testing inside your unit tests.\n\nThe `snap_assert` macro inserts the result of evaluating its argument directly into your source code as its second argument.\n`snap_assert` with two arguments becomes a regular `ex_unit` assert.","ref":"readme.html"},{"type":"extras","title":"Installation - snap_assert","doc":"If [available in Hex](https://hex.pm/docs/publish), the package can be installed\nby adding `snap_assert` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:snap_assert, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be generated with [ExDoc](https://github.com/elixir-lang/ex_doc)\nand published on [HexDocs](https://hexdocs.pm). Once published, the docs can\nbe found at  .","ref":"readme.html#installation"},{"type":"extras","title":"Usage - snap_assert","doc":"1. Import `Snap` in your test file\n2. Use `snap_assert  ` in one of the tests\n3. Run the tests with `mix test`\n4. Tests will pass and `snap_assert  ` will turn into `snap_assert  ,  `\n5. Run the tests again; `snap_assert` with two arguments will now be equivalent to a regular assert so tests will pass.\n\nMore concrete example:\n\n- Add `snap_assert(String.upcase(\"hello\"))` to a test\n- Run `mix test` (tests will pass)\n- The test file is now updated so that you have `snap_assert(String.upcase(\"hello\"), \"HELLO\")`\n- Run `mix test` again - tests will pass\n- Change the expression to `snap_assert(String.upcase(\"hello\"), \"GOODBYE\")`\n- Run `mix test` again - tests will fail, ie. now you have a regular assert.\n\nWhen working with `snap_assert`, it's useful to have the tests run on every change, for example with:\n\n```\nfswatch lib test | mix test --listen-on-stdin --stale\n```","ref":"readme.html#usage"},{"type":"extras","title":"Why? - snap_assert","doc":"I was inspired by this post by Ian Henry: https://ianthehenry.com/posts/my-kind-of-repl/\n\nAt first, the idea of inserting the value of an expression into an assert seems tautological.\nHowever, consider how we often write functions: start with a draft implementation, try it out in the REPL,\nrealise it's incomplete, make tweaks, try again, repeat until done. Then write unit tests, possibly\nby copy-pasting from the REPL.\n\n`snap_assert` moves some of that REPL into your test file. When you run tests which include a `snap_assert`,\nyou'll see the results directly in your test file. If they are as expected - great, you now have a unit test\nfor free. If not, delete the incorrect value, fix your function, run the tests again. Rinse and repeat.\n\nI was skeptical at first, but I've been trying this macro while working on a package, and it feels good.\n\nOf course, `snap_assert` isn't suitable for all tests: sometimes you want to check for a substring match, or a pattern match,\nor check that a message is received, and in those cases you still need to use regular ex_unit functionality.","ref":"readme.html#why"}],"content_type":"text/markdown"}